Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90	(revision 8741)
@@ -12,9 +12,11 @@
    USE wrk_nemo  
    USE zdf_oce        ! vertical physics: ocean variables 
+   USE domvvl         ! Need interpolation routines 
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC Agrif_Update_Tra, Agrif_Update_Dyn,Update_Scales
+   PUBLIC Agrif_Update_Tra, Agrif_Update_Dyn, Update_Scales, Agrif_Update_vvl
+
 # if defined key_zdftke
    PUBLIC Agrif_Update_Tke
@@ -27,5 +29,5 @@
 CONTAINS
 
-   RECURSIVE SUBROUTINE Agrif_Update_Tra( )
+   SUBROUTINE Agrif_Update_Tra( )
       !!---------------------------------------------
       !!   *** ROUTINE Agrif_Update_Tra ***
@@ -56,16 +58,9 @@
       Agrif_UseSpecialValueInUpdate = .FALSE.
       !
-      IF ( lk_agrif_doupd ) THEN ! Initialisation: do recursive update:
-         CALL Agrif_ChildGrid_To_ParentGrid()
-         CALL Agrif_Update_Tra()
-         CALL Agrif_ParentGrid_To_ChildGrid()
-      ENDIF
-      !
 #endif
       !
    END SUBROUTINE Agrif_Update_Tra
 
-
-   RECURSIVE SUBROUTINE Agrif_Update_Dyn( )
+   SUBROUTINE Agrif_Update_Dyn( )
       !!---------------------------------------------
       !!   *** ROUTINE Agrif_Update_Dyn ***
@@ -140,21 +135,15 @@
 #endif
       !
-      ! Do recursive update:
-      IF ( lk_agrif_doupd ) THEN ! Initialisation: do recursive update:
-         CALL Agrif_ChildGrid_To_ParentGrid()
-         CALL Agrif_Update_Dyn()
-         CALL Agrif_ParentGrid_To_ChildGrid()
-      ENDIF
-      !
    END SUBROUTINE Agrif_Update_Dyn
 
 # if defined key_zdftke
 
-   SUBROUTINE Agrif_Update_Tke( kt )
+   SUBROUTINE Agrif_Update_Tke( )
       !!---------------------------------------------
       !!   *** ROUTINE Agrif_Update_Tke ***
       !!---------------------------------------------
       !!
-      INTEGER, INTENT(in) :: kt
+      ! 
+      IF (Agrif_Root()) RETURN
       !       
       IF( ( Agrif_NbStepint() .NE. 0 ) .AND. (kt /= 0) ) RETURN
@@ -176,5 +165,112 @@
 # endif /* key_zdftke */
 
-   SUBROUTINE updateTS( tabres, i1, i2, j1, j2, k1, k2, n1, n2, before )
+   SUBROUTINE Agrif_Update_vvl( )
+      !!---------------------------------------------
+      !!   *** ROUTINE Agrif_Update_vvl ***
+      !!---------------------------------------------
+      !
+      IF (Agrif_Root()) RETURN
+      !
+#if defined TWO_WAY  
+      !
+      IF (lwp.AND.lk_agrif_debug) Write(*,*) 'Update e3 from grid Number',Agrif_Fixed(), 'Step', Agrif_Nb_Step()
+      !
+      Agrif_UseSpecialValueInUpdate = .TRUE.
+      Agrif_SpecialValueFineGrid = 0.
+      ! 
+# if ! defined DECAL_FEEDBACK
+      CALL Agrif_Update_Variable(e3t_id, procname=updatee3t)
+# else
+      CALL Agrif_Update_Variable(e3t_id, locupdate=(/1,0/), procname=updatee3t)
+# endif 
+      !
+      Agrif_UseSpecialValueInUpdate = .FALSE.
+      !
+      CALL Agrif_ChildGrid_To_ParentGrid()
+      CALL dom_vvl_update_UVF
+      CALL Agrif_ParentGrid_To_ChildGrid()
+      !
+#endif
+      !
+   END SUBROUTINE Agrif_Update_vvl
+
+   SUBROUTINE dom_vvl_update_UVF
+      !!---------------------------------------------
+      !!       *** ROUTINE dom_vvl_update_UVF ***
+      !!---------------------------------------------
+      !!
+      INTEGER :: jk
+      REAL(wp):: zcoef
+      !!---------------------------------------------
+
+      IF (lwp.AND.lk_agrif_debug) Write(*,*) 'Finalize e3 on grid Number', &
+                  & Agrif_Fixed(), 'Step', Agrif_Nb_Step()
+
+      ! Save "old" scale factor (prior update) for subsequent asselin correction
+      ! of prognostic variables (needed to update initial state only)
+      ! -------------------------------------------------------------
+      !
+      e3u_a(:,:,:) = e3u_n(:,:,:)
+      e3v_a(:,:,:) = e3v_n(:,:,:)
+!      ua(:,:,:) = e3u_b(:,:,:)
+!      va(:,:,:) = e3v_b(:,:,:)
+      hu_a(:,:) = hu_n(:,:)
+      hv_a(:,:) = hv_n(:,:)
+
+      ! 1) NOW fields
+      !--------------
+      
+         ! Vertical scale factor interpolations
+         ! ------------------------------------
+      CALL dom_vvl_interpol( e3t_n(:,:,:), e3u_n(:,:,:) ,  'U' )
+      CALL dom_vvl_interpol( e3t_n(:,:,:), e3v_n(:,:,:) ,  'V' )
+      CALL dom_vvl_interpol( e3u_n(:,:,:), e3f_n(:,:,:) ,  'F' )
+
+      CALL dom_vvl_interpol( e3u_n(:,:,:), e3uw_n(:,:,:), 'UW' )
+      CALL dom_vvl_interpol( e3v_n(:,:,:), e3vw_n(:,:,:), 'VW' )
+
+         ! Update total depths:
+         ! --------------------
+      hu_n(:,:) = 0._wp                        ! Ocean depth at U-points
+      hv_n(:,:) = 0._wp                        ! Ocean depth at V-points
+      DO jk = 1, jpkm1
+         hu_n(:,:) = hu_n(:,:) + e3u_n(:,:,jk) * umask(:,:,jk)
+         hv_n(:,:) = hv_n(:,:) + e3v_n(:,:,jk) * vmask(:,:,jk)
+      END DO
+      !                                        ! Inverse of the local depth
+      r1_hu_n(:,:) = ssumask(:,:) / ( hu_n(:,:) + 1._wp - ssumask(:,:) )
+      r1_hv_n(:,:) = ssvmask(:,:) / ( hv_n(:,:) + 1._wp - ssvmask(:,:) )
+
+
+      ! 2) BEFORE fields:
+      !------------------
+      IF (     (.NOT.(lk_agrif_fstep.AND.(neuler==0)).AND.(ln_dynspg_exp)) &
+         & .OR.(.NOT.(lk_agrif_fstep.AND.(neuler==0)).AND.(ln_dynspg_ts    &
+         & .AND.(.NOT.ln_bt_fw)))) THEN
+         !
+         ! Vertical scale factor interpolations
+         ! ------------------------------------
+         CALL dom_vvl_interpol( e3t_b(:,:,:), e3u_b(:,:,:),  'U'  )
+         CALL dom_vvl_interpol( e3t_b(:,:,:), e3v_b(:,:,:),  'V'  )
+
+         CALL dom_vvl_interpol( e3u_b(:,:,:), e3uw_b(:,:,:), 'UW' )
+         CALL dom_vvl_interpol( e3v_b(:,:,:), e3vw_b(:,:,:), 'VW' )
+
+         ! Update total depths:
+         ! --------------------
+         hu_b(:,:) = 0._wp                     ! Ocean depth at U-points
+         hv_b(:,:) = 0._wp                     ! Ocean depth at V-points
+         DO jk = 1, jpkm1
+            hu_b(:,:) = hu_b(:,:) + e3u_b(:,:,jk) * umask(:,:,jk)
+            hv_b(:,:) = hv_b(:,:) + e3v_b(:,:,jk) * vmask(:,:,jk)
+         END DO
+         !                                     ! Inverse of the local depth
+         r1_hu_b(:,:) = ssumask(:,:) / ( hu_b(:,:) + 1._wp - ssumask(:,:) )
+         r1_hv_b(:,:) = ssvmask(:,:) / ( hv_b(:,:) + 1._wp - ssvmask(:,:) )
+      ENDIF
+      !
+   END SUBROUTINE dom_vvl_update_UVF
+
+   SUBROUTINE updateTS( tabres, i1, i2, j1, j2, k1, k2, n1, n2, before, nb, ndir )
       !!---------------------------------------------
       !!           *** ROUTINE updateT ***
@@ -183,6 +279,9 @@
       REAL(wp),DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2), INTENT(inout) :: tabres
       LOGICAL, INTENT(in) :: before
+      INTEGER, INTENT(in) :: nb, ndir
       !!
+      LOGICAL :: western_side, eastern_side, southern_side, northern_side 
       INTEGER :: ji,jj,jk,jn
+      REAL(wp) :: ztb, ztnu, ztno
       !!---------------------------------------------
       !
@@ -192,5 +291,8 @@
                DO jj=j1,j2
                   DO ji=i1,i2
-                     tabres(ji,jj,jk,jn) = tsn(ji,jj,jk,jn)
+!> jc tmp
+                     tabres(ji,jj,jk,jn) = tsn(ji,jj,jk,jn)  * e3t_n(ji,jj,jk) / e3t_0(ji,jj,jk)
+!                     tabres(ji,jj,jk,jn) = tsn(ji,jj,jk,jn)  * e3t_n(ji,jj,jk)
+!< jc tmp
                   END DO
                END DO
@@ -198,4 +300,10 @@
          END DO
       ELSE
+!> jc tmp
+         DO jn = n1,n2
+            tabres(i1:i2,j1:j2,k1:k2,jn) =  tabres(i1:i2,j1:j2,k1:k2,jn) * e3t_0(i1:i2,j1:j2,k1:k2) &
+                                         & * tmask(i1:i2,j1:j2,k1:k2)
+         ENDDO
+!< jc tmp
          IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN
             ! Add asselin part
@@ -205,7 +313,9 @@
                      DO ji=i1,i2
                         IF( tabres(ji,jj,jk,jn) .NE. 0. ) THEN
-                           tsb(ji,jj,jk,jn) = tsb(ji,jj,jk,jn) & 
-                                 & + atfp * ( tabres(ji,jj,jk,jn) &
-                                 &             - tsn(ji,jj,jk,jn) ) * tmask(ji,jj,jk)
+                           ztb  = tsb(ji,jj,jk,jn) * e3t_b(ji,jj,jk) ! fse3t_b prior update should be used
+                           ztnu = tabres(ji,jj,jk,jn)
+                           ztno = tsn(ji,jj,jk,jn) * e3t_a(ji,jj,jk)
+                           tsb(ji,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(ji,jj,jk) / e3t_b(ji,jj,jk)
                         ENDIF
                      ENDDO
@@ -219,5 +329,5 @@
                   DO ji=i1,i2
                      IF( tabres(ji,jj,jk,jn) .NE. 0. ) THEN 
-                        tsn(ji,jj,jk,jn) = tabres(ji,jj,jk,jn) * tmask(ji,jj,jk)
+                        tsn(ji,jj,jk,jn) = tabres(ji,jj,jk,jn) / e3t_n(ji,jj,jk)
                      END IF
                   END DO
@@ -225,4 +335,111 @@
             END DO
          END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            tsb(i1:i2,j1:j2,k1:k2,n1:n2)  = tsn(i1:i2,j1:j2,k1:k2,n1:n2)
+         ENDIF
+         !
+         !
+# if defined DECAL_FEEDBACK
+         IF (.NOT.ln_linssh) THEN 
+            western_side  = (nb == 1).AND.(ndir == 1)
+            eastern_side  = (nb == 1).AND.(ndir == 2)
+            southern_side = (nb == 2).AND.(ndir == 1)
+            northern_side = (nb == 2).AND.(ndir == 2)
+            !
+            ! Asselin correction 
+            IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN
+               IF (southern_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO ji=i1,i2
+                           ztb  = tsb(ji,j1-1,jk,jn) * e3t_b(ji,j1-1,jk) ! fse3t_b prior update should be used
+                           ztnu = tsn(ji,j1-1,jk,jn) * e3t_n(ji,j1-1,jk)
+                           ztno = tsn(ji,j1-1,jk,jn) * e3t_a(ji,j1-1,jk)
+                           tsb(ji,j1-1,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(ji,j1-1,jk) / e3t_b(ji,j1-1,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+               IF (northern_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO ji=i1,i2
+                           ztb  = tsb(ji,j2+1,jk,jn) * e3t_b(ji,j2+1,jk) ! fse3t_b prior update should be used
+                           ztnu = tsn(ji,j2+1,jk,jn) * e3t_n(ji,j2+1,jk)
+                           ztno = tsn(ji,j2+1,jk,jn) * e3t_a(ji,j2+1,jk)
+                           tsb(ji,j2+1,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(ji,j2+1,jk) / e3t_b(ji,j2+1,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+               IF (western_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO jj=j1,j2
+                           ztb  = tsb(i1-1,jj,jk,jn) * e3t_b(i1-1,jj,jk) ! fse3t_b prior update should be used
+                           ztnu = tsn(i1-1,jj,jk,jn) * e3t_n(i1-1,jj,jk)
+                           ztno = tsn(i1-1,jj,jk,jn) * e3t_a(i1-1,jj,jk)
+                           tsb(i1-1,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(i1-1,jj,jk) / e3t_b(i1-1,jj,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+               IF (eastern_side) THEN
+                  DO jn = n1,n2
+                     DO jk=k1,k2
+                        DO jj=j1,j2
+                           ztb  = tsb(i2+1,jj,jk,jn) * e3t_b(i2+1,jj,jk) ! fse3t_b prior update should be used
+                           ztnu = tsn(i2+1,jj,jk,jn) * e3t_n(i2+1,jj,jk)
+                           ztno = tsn(i2+1,jj,jk,jn) * e3t_a(i2+1,jj,jk)
+                           tsb(i2+1,jj,jk,jn) = ( ztb + atfp * ( ztnu - ztno) )  & 
+                                     &        * tmask(i2+1,jj,jk) / e3t_b(i2+1,jj,jk)
+                        END DO
+                     ENDDO
+                  ENDDO
+               ENDIF
+            ENDIF ! Asselin correction
+
+            IF (southern_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO ji=i1,i2
+                        tsn(ji,j1-1,jk,jn) = tsn(ji,j1-1,jk,jn) * e3t_a(ji,j1-1,jk) / e3t_n(ji,j1-1,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+            IF (northern_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO ji=i1,i2
+                        tsn(ji,j2+1,jk,jn) = tsn(ji,j2+1,jk,jn) * e3t_a(ji,j2+1,jk) / e3t_n(ji,j2+1,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+            IF (western_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO jj=j1,j2
+                        tsn(i1-1,jj,jk,jn) = tsn(i1-1,jj,jk,jn) * e3t_a(i1-1,jj,jk) / e3t_n(i1-1,jj,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+            IF (eastern_side) THEN
+               DO jn = n1,n2
+                  DO jk=k1,k2
+                     DO jj=j1,j2
+                        tsn(i2+1,jj,jk,jn) = tsn(i2+1,jj,jk,jn) * e3t_a(i2+1,jj,jk) / e3t_n(i2+1,jj,jk)
+                     END DO
+                  ENDDO
+               ENDDO
+            ENDIF
+         ENDIF
+#endif
       ENDIF
       ! 
@@ -238,6 +455,6 @@
       LOGICAL                               , INTENT(in   ) :: before
       !
-      INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zrhoy
+      INTEGER  :: ji, jj, jk
+      REAL(wp) :: zrhoy, zub, zunu, zuno
       !!---------------------------------------------
       ! 
@@ -251,15 +468,23 @@
             DO jj=j1,j2
                DO ji=i1,i2
-                  tabres(ji,jj,jk) = tabres(ji,jj,jk) * r1_e2u(ji,jj) / e3u_n(ji,jj,jk)
+                  tabres(ji,jj,jk) = tabres(ji,jj,jk) * r1_e2u(ji,jj) 
                   !
                   IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN ! Add asselin part
-                     ub(ji,jj,jk) = ub(ji,jj,jk) & 
-                           & + atfp * ( tabres(ji,jj,jk) - un(ji,jj,jk) ) * umask(ji,jj,jk)
+                     zub  = ub(ji,jj,jk) * e3u_b(ji,jj,jk)
+                     zuno = un(ji,jj,jk) * e3u_a(ji,jj,jk)
+                     zunu = tabres(ji,jj,jk)
+                     ub(ji,jj,jk) = ( zub + atfp * ( zunu - zuno) ) &      
+                                    & * umask(ji,jj,jk) / e3u_b(ji,jj,jk)
                   ENDIF
                   !
-                  un(ji,jj,jk) = tabres(ji,jj,jk) * umask(ji,jj,jk)
-               END DO
-            END DO
-         END DO
+                  un(ji,jj,jk) = tabres(ji,jj,jk) * umask(ji,jj,jk) / e3u_n(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            ub(i1:i2,j1:j2,k1:k2)  = un(i1:i2,j1:j2,k1:k2)
+         ENDIF
+         !
       ENDIF
       ! 
@@ -267,14 +492,14 @@
 
 
-   SUBROUTINE updatev( tabres, i1, i2, j1, j2, k1, k2, before )
+   SUBROUTINE updatev( tabres, i1, i2, j1, j2, k1, k2, before)
       !!---------------------------------------------
       !!           *** ROUTINE updatev ***
       !!---------------------------------------------
-      INTEGER :: i1,i2,j1,j2,k1,k2
-      INTEGER :: ji,jj,jk
-      REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2) :: tabres
-      LOGICAL :: before
-      !!
-      REAL(wp) :: zrhox
+      INTEGER                               , INTENT(in   ) :: i1, i2, j1, j2, k1, k2
+      REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2), INTENT(inout) :: tabres
+      LOGICAL                               , INTENT(in   ) :: before
+      !
+      INTEGER  :: ji, jj, jk
+      REAL(wp) :: zrhox, zvb, zvnu, zvno
       !!---------------------------------------------      
       !
@@ -292,15 +517,23 @@
             DO jj=j1,j2
                DO ji=i1,i2
-                  tabres(ji,jj,jk) = tabres(ji,jj,jk) * r1_e1v(ji,jj) / e3v_n(ji,jj,jk)
+                  tabres(ji,jj,jk) = tabres(ji,jj,jk) * r1_e1v(ji,jj)
                   !
                   IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN ! Add asselin part
-                     vb(ji,jj,jk) = vb(ji,jj,jk) & 
-                           & + atfp * ( tabres(ji,jj,jk) - vn(ji,jj,jk) ) * vmask(ji,jj,jk)
+                     zvb  = vb(ji,jj,jk) * e3v_b(ji,jj,jk)
+                     zvno = vn(ji,jj,jk) * e3v_a(ji,jj,jk)
+                     zvnu = tabres(ji,jj,jk)
+                     vb(ji,jj,jk) = ( zvb + atfp * ( zvnu - zvno) ) &      
+                                    & * vmask(ji,jj,jk) / e3v_b(ji,jj,jk)
                   ENDIF
                   !
-                  vn(ji,jj,jk) = tabres(ji,jj,jk) * vmask(ji,jj,jk)
-               END DO
-            END DO
-         END DO
+                  vn(ji,jj,jk) = tabres(ji,jj,jk) * vmask(ji,jj,jk) / e3v_n(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            vb(i1:i2,j1:j2,k1:k2)  = vn(i1:i2,j1:j2,k1:k2)
+         ENDIF
+         !
       ENDIF
       ! 
@@ -316,5 +549,5 @@
       LOGICAL, INTENT(in) :: before
       !! 
-      INTEGER :: ji, jj, jk
+      INTEGER  :: ji, jj, jk
       REAL(wp) :: zrhoy
       REAL(wp) :: zcorr
@@ -331,5 +564,5 @@
          DO jj=j1,j2
             DO ji=i1,i2
-               tabres(ji,jj) =  tabres(ji,jj) * r1_hu_n(ji,jj) * r1_e2u(ji,jj)  
+               tabres(ji,jj) =  tabres(ji,jj) * r1_e2u(ji,jj)  
                !    
                ! Update "now" 3d velocities:
@@ -338,7 +571,6 @@
                   spgu(ji,jj) = spgu(ji,jj) + e3u_n(ji,jj,jk) * un(ji,jj,jk)
                END DO
-               spgu(ji,jj) = spgu(ji,jj) * r1_hu_n(ji,jj)
                !
-               zcorr = tabres(ji,jj) - spgu(ji,jj)
+               zcorr = (tabres(ji,jj) - spgu(ji,jj)) * r1_hu_n(ji,jj)
                DO jk=1,jpkm1              
                   un(ji,jj,jk) = un(ji,jj,jk) + zcorr * umask(ji,jj,jk)           
@@ -348,9 +580,9 @@
                IF ( .NOT.ln_dynspg_ts .OR. (ln_dynspg_ts.AND.(.NOT.ln_bt_fw)) ) THEN
                   IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN ! Add asselin part
-                     zcorr = tabres(ji,jj) - un_b(ji,jj)
+                     zcorr = (tabres(ji,jj) - un_b(ji,jj) * hu_a(ji,jj)) * r1_hu_b(ji,jj)
                      ub_b(ji,jj) = ub_b(ji,jj) + atfp * zcorr * umask(ji,jj,1)
                   END IF
-               ENDIF             
-               un_b(ji,jj) = tabres(ji,jj) * umask(ji,jj,1)
+               ENDIF    
+               un_b(ji,jj) = tabres(ji,jj) * r1_hu_n(ji,jj) * umask(ji,jj,1)
                !       
                ! Correct "before" velocities to hold correct bt component:
@@ -359,7 +591,6 @@
                   spgu(ji,jj) = spgu(ji,jj) + e3u_b(ji,jj,jk) * ub(ji,jj,jk)
                END DO
-               spgu(ji,jj) = spgu(ji,jj) * r1_hu_b(ji,jj)
                !
-               zcorr = ub_b(ji,jj) - spgu(ji,jj)
+               zcorr = ub_b(ji,jj) - spgu(ji,jj) * r1_hu_b(ji,jj)
                DO jk=1,jpkm1              
                   ub(ji,jj,jk) = ub(ji,jj,jk) + zcorr * umask(ji,jj,jk)           
@@ -368,4 +599,8 @@
             END DO
          END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            ub_b(i1:i2,j1:j2)  = un_b(i1:i2,j1:j2)
+         ENDIF
       ENDIF
       !
@@ -381,5 +616,5 @@
       LOGICAL, INTENT(in) :: before
       !! 
-      INTEGER :: ji, jj, jk
+      INTEGER  :: ji, jj, jk
       REAL(wp) :: zrhox
       REAL(wp) :: zcorr
@@ -396,5 +631,5 @@
          DO jj=j1,j2
             DO ji=i1,i2
-               tabres(ji,jj) =  tabres(ji,jj) * r1_hv_n(ji,jj) * r1_e1v(ji,jj)  
+               tabres(ji,jj) =  tabres(ji,jj) * r1_e1v(ji,jj)  
                !    
                ! Update "now" 3d velocities:
@@ -403,7 +638,6 @@
                   spgv(ji,jj) = spgv(ji,jj) + e3v_n(ji,jj,jk) * vn(ji,jj,jk)
                END DO
-               spgv(ji,jj) = spgv(ji,jj) * r1_hv_n(ji,jj)
                !
-               zcorr = tabres(ji,jj) - spgv(ji,jj)
+               zcorr = (tabres(ji,jj) - spgv(ji,jj)) * r1_hv_n(ji,jj)
                DO jk=1,jpkm1              
                   vn(ji,jj,jk) = vn(ji,jj,jk) + zcorr * vmask(ji,jj,jk)           
@@ -413,9 +647,9 @@
                IF ( .NOT.ln_dynspg_ts .OR. (ln_dynspg_ts.AND.(.NOT.ln_bt_fw)) ) THEN
                   IF (.NOT.(lk_agrif_fstep.AND.(neuler==0))) THEN ! Add asselin part
-                     zcorr = tabres(ji,jj) - vn_b(ji,jj)
+                     zcorr = (tabres(ji,jj) - vn_b(ji,jj) * hv_a(ji,jj)) * r1_hv_b(ji,jj)
                      vb_b(ji,jj) = vb_b(ji,jj) + atfp * zcorr * vmask(ji,jj,1)
                   END IF
                ENDIF              
-               vn_b(ji,jj) = tabres(ji,jj) * vmask(ji,jj,1)
+               vn_b(ji,jj) = tabres(ji,jj) * r1_hv_n(ji,jj) * vmask(ji,jj,1)
                !       
                ! Correct "before" velocities to hold correct bt component:
@@ -424,7 +658,6 @@
                   spgv(ji,jj) = spgv(ji,jj) + e3v_b(ji,jj,jk) * vb(ji,jj,jk)
                END DO
-               spgv(ji,jj) = spgv(ji,jj) * r1_hv_b(ji,jj)
                !
-               zcorr = vb_b(ji,jj) - spgv(ji,jj)
+               zcorr = vb_b(ji,jj) - spgv(ji,jj) * r1_hv_b(ji,jj)
                DO jk=1,jpkm1              
                   vb(ji,jj,jk) = vb(ji,jj,jk) + zcorr * vmask(ji,jj,jk)           
@@ -433,4 +666,9 @@
             END DO
          END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            vb_b(i1:i2,j1:j2)  = vn_b(i1:i2,j1:j2)
+         ENDIF
+         !
       ENDIF
       ! 
@@ -438,5 +676,5 @@
 
 
-   SUBROUTINE updateSSH( tabres, i1, i2, j1, j2, before )
+   SUBROUTINE updateSSH( tabres, i1, i2, j1, j2, before, nb, ndir )
       !!---------------------------------------------
       !!          *** ROUTINE updateSSH ***
@@ -445,5 +683,7 @@
       REAL(wp), DIMENSION(i1:i2,j1:j2), INTENT(inout) :: tabres
       LOGICAL, INTENT(in) :: before
+      INTEGER, INTENT(in) :: nb, ndir
       !!
+      LOGICAL :: western_side, eastern_side, southern_side, northern_side 
       INTEGER :: ji, jj
       !!---------------------------------------------
@@ -472,4 +712,40 @@
             END DO
          END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            sshb(i1:i2,j1:j2)  = sshn(i1:i2,j1:j2)
+         ENDIF
+         !
+# if defined DECAL_FEEDBACK
+!         western_side  = (nb == 1).AND.(ndir == 1)
+!         eastern_side  = (nb == 1).AND.(ndir == 2)
+!         southern_side = (nb == 2).AND.(ndir == 1)
+!         northern_side = (nb == 2).AND.(ndir == 2)
+!         !
+!         ! Asselin correction 
+!         IF ( ln_dynspg_ts.AND.ln_bt_fw ) THEN
+!            IF (southern_side) THEN
+!               DO ji=i1,i2
+!                  sshn(ji,j1-1) = sshn(ji,j1-1) - rdt * r1_e2t(ji,j1-1) * (vb2_b_s(ji,j1-1)-vb2_b(ji,j1-1))
+!               END DO
+!            ENDIF
+!            IF (northern_side) THEN
+!               DO ji=i1,i2
+!                  sshn(ji,j1+1) = sshn(ji,j1+1) + rdt * r1_e2t(ji,j1+1) * (vb2_b_s(ji,j1)-vb2_b(ji,j1))
+!               END DO
+!            ENDIF
+!            IF (western_side) THEN
+!               DO jj=j1,j2
+!                  sshn(i1-1,jj) = sshn(i1-1,jj) - rdt * r1_e2t(i1-1,jj) * (ub2_b_s(i1-1,jj)-ub2_b(i1-1,jj))
+!               END DO
+!            ENDIF
+!            IF (eastern_side) THEN
+!               DO jj=j1,j2
+!                  sshn(i1+1,jj) = sshn(i1+1,jj) + rdt * r1_e2t(i1+1,jj) * (ub2_b_s(i1,jj)-ub2_b(i1,jj))
+!               END DO
+!            ENDIF
+!            ! 
+!         ENDIF
+#endif
       ENDIF
       !
@@ -486,5 +762,5 @@
       !!
       INTEGER :: ji, jj
-      REAL(wp) :: zrhoy
+      REAL(wp) :: zrhoy, za1
       !!---------------------------------------------
       !
@@ -498,7 +774,12 @@
          tabres = zrhoy * tabres
       ELSE
+         za1 = 1._wp / REAL(Agrif_rhot(), wp)
+         tabres(i1:i2,j1:j2) = tabres(i1:i2,j1:j2) * r1_e2u(i1:i2,j1:j2)
          DO jj=j1,j2
             DO ji=i1,i2
-               ub2_b(ji,jj) = tabres(ji,jj) / e2u(ji,jj)
+               ub2_i_b(ji,jj) = ub2_i_b(ji,jj) & 
+                & + za1 * (tabres(ji,jj) - ub2_b(ji,jj))
+!               ub2_b_s(ji,jj) = ub2_b(ji,jj)
+               ub2_b(ji,jj) = tabres(ji,jj)
             END DO
          END DO
@@ -517,5 +798,5 @@
       !!
       INTEGER :: ji, jj
-      REAL(wp) :: zrhox
+      REAL(wp) :: zrhox, za1
       !!---------------------------------------------
       !
@@ -529,7 +810,12 @@
          tabres = zrhox * tabres
       ELSE
+         za1 = 1._wp / REAL(Agrif_rhot(), wp)
+         tabres(i1:i2,j1:j2) = tabres(i1:i2,j1:j2) * r1_e1v(i1:i2,j1:j2)
          DO jj=j1,j2
             DO ji=i1,i2
-               vb2_b(ji,jj) = tabres(ji,jj) / e1v(ji,jj)
+               vb2_i_b(ji,jj) = vb2_i_b(ji,jj) & 
+                & + za1 * (tabres(ji,jj) - vb2_b(ji,jj))
+!               vb2_b_s(ji,jj) = vb2_b(ji,jj)
+               vb2_b(ji,jj) = tabres(ji,jj)
             END DO
          END DO
@@ -644,4 +930,122 @@
 # endif /* key_zdftke */ 
 
+   SUBROUTINE updatee3t( ptab, i1, i2, j1, j2, k1, k2, before )
+      !!---------------------------------------------
+      !!           *** ROUTINE updatee3t ***
+      !!---------------------------------------------
+      INTEGER, INTENT(in) :: i1, i2, j1, j2, k1, k2
+      REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2), INTENT(inout) :: ptab
+      LOGICAL, INTENT(in) :: before
+      INTEGER :: ji,jj,jk
+      REAL(wp) :: zcoef
+      !!---------------------------------------------
+      !
+      IF (before) THEN
+!> jc tmp:
+!         ptab(i1:i2,j1:j2,k1:k2) = e3t_n(i1:i2,j1:j2,k1:k2)
+         ptab(i1:i2,j1:j2,k1:k2) = e3t_n(i1:i2,j1:j2,k1:k2) / e3t_0(i1:i2,j1:j2,k1:k2) * tmask(i1:i2,j1:j2,k1:k2)
+!< jc tmp:
+      ELSE
+         !
+         ! 1) Updates at BEFORE time step:
+         ! -------------------------------
+         !
+!> jc tmp:
+!         DO jk = 1, jpkm1
+!            DO jj=j1,j2
+!               DO ji=i1,i2
+!                  IF (tmask(ji,jj,jk)==1) THEN
+!                     ptab(ji,jj,jk) = ptab(ji,jj,jk) * e3t_0(ji,jj,jk)
+!                  ELSE
+!                     ptab(ji,jj,jk) = e3t_0(ji,jj,jk)
+!                  ENDIF
+!               END DO
+!            END DO
+!         END DO
+         ptab(i1:i2,j1:j2,k1:k2) = ptab(i1:i2,j1:j2,k1:k2) * e3t_0(i1:i2,j1:j2,k1:k2)
+!< jc tmp:
+
+         ! Save "old" scale factor (prior update) for subsequent asselin correction
+         ! of prognostic variables (needed to update initial state only)
+         e3t_a(i1:i2,j1:j2,k1:k2) = e3t_n(i1:i2,j1:j2,k1:k2)
+!         hdivb(i1:i2,j1:j2,k1:k2)   = e3t_b(i1:i2,j1:j2,k1:k2)
+
+         IF (     (.NOT.(lk_agrif_fstep.AND.(neuler==0)).AND.(ln_dynspg_exp)) &
+            & .OR.(.NOT.(lk_agrif_fstep.AND.(neuler==0)).AND.(ln_dynspg_ts    &
+            & .AND.(.NOT.ln_bt_fw)))) THEN
+
+            DO jk = 1, jpkm1
+               DO jj=j1,j2
+                  DO ji=i1,i2
+                     e3t_b(ji,jj,jk) =  e3t_b(ji,jj,jk) &
+                           & + atfp * ( ptab(ji,jj,jk) - e3t_n(ji,jj,jk) )
+                  END DO
+               END DO
+            END DO
+            !
+            e3w_b  (i1:i2,j1:j2,1) = e3w_0(i1:i2,j1:j2,1) + e3t_b(i1:i2,j1:j2,1) - e3t_0(i1:i2,j1:j2,1)
+            gdepw_b(i1:i2,j1:j2,1) = 0.0_wp
+            gdept_b(i1:i2,j1:j2,1) = 0.5_wp * e3w_b(i1:i2,j1:j2,1)
+            !
+            DO jk = 2, jpk
+               DO jj = j1,j2
+                  DO ji = i1,i2            
+                     zcoef = (tmask(ji,jj,jk) - wmask(ji,jj,jk))
+                     e3w_b(ji,jj,jk)  = e3w_0(ji,jj,jk) + ( 1.0_wp - 0.5_wp * tmask(ji,jj,jk) ) *        & 
+                     &                                        ( e3t_b(ji,jj,jk-1) - e3t_0(ji,jj,jk-1) )  &
+                     &                                  +            0.5_wp * tmask(ji,jj,jk)   *        &
+                     &                                        ( e3t_b(ji,jj,jk  ) - e3t_0(ji,jj,jk  ) )
+                     gdepw_b(ji,jj,jk) = gdepw_b(ji,jj,jk-1) + e3t_b(ji,jj,jk-1)
+                     gdept_b(ji,jj,jk) =      zcoef  * ( gdepw_b(ji,jj,jk  ) + 0.5 * e3w_b(ji,jj,jk))  &
+                         &               + (1-zcoef) * ( gdept_b(ji,jj,jk-1) +       e3w_b(ji,jj,jk)) 
+                  END DO
+               END DO
+            END DO
+            !
+         ENDIF        
+         !
+         ! 2) Updates at NOW time step:
+         ! ----------------------------
+         !
+         ! Update vertical scale factor at T-points:
+         e3t_n(i1:i2,j1:j2,k1:k2) = ptab(i1:i2,j1:j2,k1:k2)
+         !
+         ! Update total depth:
+         ht_n(i1:i2,j1:j2) = 0._wp
+         DO jk = 1, jpkm1
+            ht_n(i1:i2,j1:j2) = ht_n(i1:i2,j1:j2) + e3t_n(i1:i2,j1:j2,jk) * tmask(i1:i2,j1:j2,jk)
+         END DO
+         !
+         ! Update vertical scale factor at W-points and depths:
+         e3w_n (i1:i2,j1:j2,1) = e3w_0(i1:i2,j1:j2,1) + e3t_n(i1:i2,j1:j2,1) - e3t_0(i1:i2,j1:j2,1)
+         gdept_n(i1:i2,j1:j2,1) = 0.5_wp * e3w_n(i1:i2,j1:j2,1)
+         gdepw_n(i1:i2,j1:j2,1) = 0.0_wp
+         gde3w_n(i1:i2,j1:j2,1) = gdept_n(i1:i2,j1:j2,1) - (ht_n(i1:i2,j1:j2)-ht_0(i1:i2,j1:j2)) ! Last term in the rhs is ssh
+         !
+         DO jk = 2, jpk
+            DO jj = j1,j2
+               DO ji = i1,i2            
+               zcoef = (tmask(ji,jj,jk) - wmask(ji,jj,jk))
+               e3w_n(ji,jj,jk)  = e3w_0(ji,jj,jk) + ( 1.0_wp - 0.5_wp * tmask(ji,jj,jk) ) * ( e3t_n(ji,jj,jk-1) - e3t_0(ji,jj,jk-1) )   &
+               &                                  +            0.5_wp * tmask(ji,jj,jk)   * ( e3t_n(ji,jj,jk  ) - e3t_0(ji,jj,jk  ) )
+               gdepw_n(ji,jj,jk) = gdepw_n(ji,jj,jk-1) + e3t_n(ji,jj,jk-1)
+               gdept_n(ji,jj,jk) =      zcoef  * ( gdepw_n(ji,jj,jk  ) + 0.5 * e3w_n(ji,jj,jk))  &
+                   &               + (1-zcoef) * ( gdept_n(ji,jj,jk-1) +       e3w_n(ji,jj,jk)) 
+               gde3w_n(ji,jj,jk) = gdept_n(ji,jj,jk) - (ht_n(ji,jj)-ht_0(ji,jj)) ! Last term in the rhs is ssh
+               END DO
+            END DO
+         END DO
+         !
+         IF  ((neuler==0).AND.(Agrif_Nb_Step()==0) ) THEN
+            e3t_b (i1:i2,j1:j2,1:jpk)  = e3t_n (i1:i2,j1:j2,1:jpk)
+            e3w_b (i1:i2,j1:j2,1:jpk)  = e3w_n (i1:i2,j1:j2,1:jpk)
+            gdepw_b(i1:i2,j1:j2,1:jpk) = gdepw_n(i1:i2,j1:j2,1:jpk)
+            gdept_b(i1:i2,j1:j2,1:jpk) = gdept_n(i1:i2,j1:j2,1:jpk)
+         ENDIF
+         !
+      ENDIF
+      !
+   END SUBROUTINE updatee3t
+
 #else
 CONTAINS
